
/**
 * Created by IntelliJ IDEA.
 * User: naeem
 * Date: Mar 24, 2004
 * Time: 10:36:05 AM
 */

/**
 * This thread is producer ehich means it writes items to queue that assigned to it
 * this thread stops when its queue goes in except condition
 */
public class Writer extends Thread {
    public Writer(Queue myq) {
        q = myq;
    }

    /**
     * It produces till queue is in except condition
     */
    public void run() {
        while (!q.isExcept()) {
            synchronized (q) {
//                System.out.println( "" + counter + " - " + except);
                if (q.isExcept())
                    break;

                try {
                    q.Enqueue(counter++);
                    System.out.println("Wrote: " + counter);
                } catch (QueueIsFullException e) {
                    q.setExcept();
                    System.out.println("Couldn't write " + e.getElement() + " because queue is full!!");
                }
            }
        }
    }

    /**
     * This field is used as same counter for all writers
     */
    static private int counter = 0;

    /**
     * Assigned queue
     */
    private Queue q = null;
}
